#include "bsp.hh"

static const w3 verts[] =
{
    /* 0,1,2,3, 4,5,6,7 */
    {  0,  0, 0},
    {  0,500, 0},
    {500,500, 0},
    {500,  0, 0},
    {  0,  0,80},
    {  0,500,80},
    {500,500,80},
    {500,  0,80},
    
    /* 8,9,10,11, 12,13,14,15 */
    {200,100, 0},
    {300,100, 0},
    {200,200, 0},
    {210,200, 0},
    {290,200, 0},
    {300,200, 0},
    {290, 40, 0},
    {210, 40, 0},
    
    /* 16,17,18,19, 20,21,22,23 */
    {200,100,70},
    {300,100,70},
    {200,200,70},
    {210,200,50},
    {290,200,50},
    {300,200,70},
    {290, 40,50},
    {210, 40,50},
};

/* A field with a tunnel going through solid wall. */
static const wall walls[] =
{
    { 0, 2}, /* floor */
    
    /* 1..5 */
    { 0, 7}, /* outer wall begin */
    { 3, 6},
    { 2, 5},
    { 1, 4}, /* outer wall end */
    
    /* 6,7,8,9, 10,11,12,13 */    
    {12,21}, /* - solid wall front */
    {13,17}, /* | solid wall side */
    { 9,16}, /* _ solid wall back */
    { 8,18}, /* | solid wall side */
    {10,19}, /* - solid wall front */
    {11,23}, /* | inside wall edges */
    {15,22}, /* ~ */
    {14,20}, /* | */
    
    /* 14,15 */
    {16,21}, /* subtop ceiling */
    {21,19}, /* inner ceiling */

    /* 16 */
    {12,19} /* middle top wall */
};

static struct bsp *recursivebuildbsp(
    vector<unsigned>::const_iterator xmib,
    vector<unsigned>::const_iterator xmie,
    vector<unsigned>::const_iterator ymib,
    vector<unsigned>::const_iterator ymie,
    vector<unsigned>::const_iterator zmib,
    vector<unsigned>::const_iterator zmie,
    vector<unsigned>::const_iterator xmab,
    vector<unsigned>::const_iterator xmae,
    vector<unsigned>::const_iterator ymab,
    vector<unsigned>::const_iterator ymae,
    vector<unsigned>::const_iterator zmab,
    vector<unsigned>::const_iterator zmae)
{
	unsigned x1s = xmie-xmib, x2s = xmae-xmab;
	unsigned y1s = ymie-ymib, y2s = ymae-ymab;
	unsigned z1s = zmie-zmib, z2s = zmae-zmab;
	
	unsigned x = (walls[*(xmie-1)-> + *(xmab)) / 2;
	unsigned y = (walls[*(ymie-1)-> + *(ymab)) / 2;
	unsigned z = (walls[*(zmie-1)-> + *(zmab)) / 2;
	
	bsp *tmp = new bsp;
	
	tmp->point.set(x,y,z);
	tmp
	
}

static void buildbsp()
{
	vector<unsigned> xmi(sizeof(walls) / sizeof(walls[0]));
	for(unsigned a=0; a<xmi.size(); ++a)xmi[a] = a;
	
	vector<unsigned> xma=xmi, ymi=xmi, yma=xmi, zmi=xmi, zma=xmi;
	
	#define sorty(key, op) static struct { bool operator() (unsigned a, unsigned b) const \
	    { return walls[a].op() < walls[b].op(); } } key##sort; sort(key, key##sort)
	
	sorty(xmi, xmin);
	sorty(ymi, ymin);
	sorty(zmi, zmin);
	sorty(xma, xmax);
	sorty(yma, ymax);
	sorty(zma, zmax);
	
	recursivebuildbsp(
	    xmi.begin(), xmi.end(),
	    ymi.begin(), ymi.end(),
	    zmi.begin(), zmi.end(),
	    xma.begin(), xma.end(),
	    yma.begin(), yma.end(),
	    zma.begin(), zma.end(),
	    
	    );
}
